--[[
    
***************************************************************
Created by: mrfatpockets (1dabread)
Date: Today
Description:
TODO: Add more items
***************************************************************

]]

Assets = {
    Asset("ATLAS", "images/inventoryimages/trap_beespring.xml"),
    Asset("IMAGE", "images/inventoryimages/trap_beespring.tex"),
    Asset("IMAGE", "images/inventoryimages/driftwood_stinger.tex"),
    Asset("ATLAS", "images/inventoryimages/driftwood_stinger.xml"),
    Asset("ATLAS", "images/inventoryimages/thorn_crown.xml"),
    Asset("IMAGE", "images/inventoryimages/thorn_crown.tex"),
    Asset("ANIM", "anim/poison.zip"),
}

PrefabFiles = {
	"trap_beespring",
	"driftwood_stinger",
	"thorn_crown",
	"poison"
}

local require 	 = GLOBAL.require
local RECIPETABS = GLOBAL.RECIPETABS
local TECH		 = GLOBAL.TECH

Vector3 = GLOBAL.Vector3

-- Configuration Data
GLOBAL.costmultiplier = GetModConfigData("costmultiplier")
GLOBAL.dmgmultiplier  = GetModConfigData("dmgmultiplier")
GLOBAL.usemultiplier  = GetModConfigData("usemultiplier")

------------------------------------
--[[ Item Info ]]--
--- Bee Stinger Trap
GLOBAL.STRINGS.NAMES.TRAP_BEESPRING = "Bee Stinger Trap"
GLOBAL.STRINGS.RECIPE_DESC.TRAP_BEESPRING = "Bee butts wrapped in twine."
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.TRAP_BEESPRING = "Little buggers just became more useful."
local trap_beespring = Recipe(	"trap_beespring", 
								{
									Ingredient("twigs", math.ceil(2 * GLOBAL.costmultiplier)),
									Ingredient("rope", math.ceil(1 * GLOBAL.costmultiplier)),
									Ingredient("stinger", math.ceil(2 * GLOBAL.costmultiplier))
								}, 
								RECIPETABS.WAR,  
								TECH.SCIENCE_ONE)
trap_beespring.atlas = "images/inventoryimages/trap_beespring.xml"
-- Driftwood Stinger Bat
GLOBAL.STRINGS.NAMES.DRIFTWOOD_STINGER = "Driftwood Stinger Club"
GLOBAL.STRINGS.RECIPE_DESC.DRIFTWOOD_STINGER = "It's a board with a stinger through it."
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.DRIFTWOOD_STINGER = "Little buggers just became more useful."
local driftwood_stinger = Recipe(	"driftwood_stinger", 
								{
									Ingredient("boards", math.ceil(1 * GLOBAL.costmultiplier)),
									Ingredient("cutgrass", math.ceil(2 * GLOBAL.costmultiplier)),
									Ingredient("stinger", math.ceil(1 * GLOBAL.costmultiplier))
								}, 
								RECIPETABS.WAR,  
								TECH.SCIENCE_ONE)
driftwood_stinger.atlas = "images/inventoryimages/driftwood_stinger.xml"
-- Crown of Thorns
GLOBAL.STRINGS.NAMES.THORN_CROWN = "Crown of Thorns"
GLOBAL.STRINGS.RECIPE_DESC.THORN_CROWN = "A crown made of sharp stingers."
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.THORN_CROWN = "Little buggers just became more useful."
local thorn_crown = Recipe(	"thorn_crown", 
								{
									Ingredient("twigs", math.ceil(2 * GLOBAL.costmultiplier)),
									Ingredient("silk", math.ceil(1 * GLOBAL.costmultiplier)),
									Ingredient("stinger", math.ceil(3 * GLOBAL.costmultiplier))
								}, 
								RECIPETABS.DRESS,  
								TECH.SCIENCE_ONE)
thorn_crown.atlas = "images/inventoryimages/thorn_crown.xml"

---------------------------------------------
--[[ POISON ]]--

POISON_TAGS = {
	epic 			= {armor = 0.5, resist = 10},
	largecreature	= {armor = 0.2, resist =  7},
	chess			= {armor = 0.8, resist = 10},
	ghost			= {armor = 1.0, resist = 99},
	bee 		 	= {armor = 0.8, resist =  5},
	pig 			= {armor = 0.2, resist =  1},

}


-- Add Poisonable component to all entities
AddPrefabPostInitAny(function(inst)
	-- Structures are not poisonable
	if inst:HasTag("structure") then
		return
	end
	-- Must have health
	if inst.components and inst.components.health then
		-- If for some reason it goes over it more than once
		if inst.components.poisonable then
			inst:RemoveComponent("poisonable")
		end

		-- Check the POISON_TAGS table for specific values
		for p,v in pairs(POISON_TAGS) do
			if inst:HasTag(p) then
				inst:AddComponent("poisonable")
				inst.components.poisonable.sicknessArmor =v.armor
	  			inst.components.poisonable.resistance = v.resist
	  			return
	  		end
		end
		inst:AddComponent("poisonable")
	end
end)

-- Add Poisonable component to all players
local function AddComponent(inst)
	if not inst.components.poisonable then
		inst:AddComponent("poisonable")
	end
	inst.components.poisonable.resistance = 9 
	inst.components.poisonable.sicknessArmor = 0
end
AddSimPostInit(AddComponent)