local assets=
{
    Asset("ANIM", "anim/driftwood_stinger.zip"),                   -- Ground Image
    Asset("ANIM", "anim/swap_driftwood_stinger.zip"),
    Asset("IMAGE", "images/inventoryimages/driftwood_stinger.tex"),-- Inventory Image
    Asset("ATLAS", "images/inventoryimages/driftwood_stinger.xml"),
}

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_driftwood_stinger", "swap_ruins_bat")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function onattack(inst, attacker, target)
    local attk = attacker.components
    local trgt = target.components

    if attk and attk.poisonable then
        attk.poisonable:AddSickness(1)
    end
    
    if trgt.poisonable then
        trgt.poisonable:AddSickness(1)
    end
    if trgt.sleeper and trgt.sleeper:IsAsleep() then
        trgt.sleeper:WakeUp()
    end
    if trgt.combat then
        trgt.combat:SuggestTarget(attacker)
        if target.sg and not target.sg:HasStateTag("poison") and target.sg.sg.states.hit then
            target.sg:GoToState("hit")
        end
    end
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("ruins_bat")
    anim:SetBuild("driftwood_stinger")
    anim:PlayAnimation("idle")
    
    inst:AddTag("sharp")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(math.ceil(10 * dmgmultiplier))
    inst.components.weapon:SetOnAttack(onattack)

    -------
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES * usemultiplier)
    inst.components.finiteuses:SetUses(TUNING.SPEAR_USES * usemultiplier)
    
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/driftwood_stinger.xml"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
    return inst
end

return Prefab( "common/inventory/driftwood_stinger", fn, assets) 
