
local assets=
{
	Asset("ANIM", "anim/thorn_crown.zip"),
	Asset("ATLAS", "images/inventoryimages/thorn_crown.xml"),
	Asset("IMAGE", "images/inventoryimages/thorn_crown.tex"),
}

local BONUS = {
    RESIST = 4,
    ARMOR  = 0.5
}

local function procfn(inst, data)
    local attk = data.attacker
    --print("Thorn Crown PROC!!!! by " .. attk.prefab)
    if attk and attk.components.poisonable then
        attk.components.poisonable:AddSickness(1)
    end
    if inst.components.poisonable then
        inst.components.poisonable:AddSickness(1)
    end
end

local function onperish (inst, owner)
    local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
    if owner then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/use_break")
        local brokentool = SpawnPrefab("brokentool")
        brokentool.Transform:SetPosition(inst.Transform:GetWorldPosition() )
    inst:Remove()
	end
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_hat", "thorn_crown", "swap_hat")
    owner.AnimState:Show("HAT")
    owner.AnimState:Hide("HAT_HAIR")
    owner.AnimState:Show("HAIR_NOHAT")
    owner.AnimState:Show("HAIR")
    owner.AnimState:Show("HEAD")
    owner.AnimState:Hide("HEAD_HAIR")
    

    if inst.components.fueled then
        inst.components.fueled:StartConsuming()        
    end
    inst.tryproc = function(inst, data) procfn(inst,data) end 
    owner:ListenForEvent("attacked", inst.tryproc)
    
    if owner.components.poisonable then
        local psn = owner.components.poisonable
        psn:SetResistanceBonus(psn.resistBonus + BONUS.RESIST)
        psn:SetSicknessArmorBonus(psn.armorBonus + BONUS.ARMOR)
    end
end

local function onunequip(inst, owner) 

	if inst.components.fueled then
		inst.components.fueled:StopConsuming()
	end
    owner.AnimState:Hide("HAT")
    owner.AnimState:Hide("HAT_HAIR")
    owner.AnimState:Show("HAIR_NOHAT")
    owner.AnimState:Show("HAIR")
		
    if owner:HasTag("player") then
        owner.AnimState:Show("HEAD")
        owner.AnimState:Hide("HEAD_HAIR")
    end
    owner:RemoveEventCallback("attacked", inst.tryproc)

    if owner.components.poisonable then
        local psn = owner.components.poisonable
        psn:SetResistanceBonus(psn.resistBonus - BONUS.RESIST)
        psn:SetSicknessArmorBonus(psn.armorBonus - BONUS.ARMOR)
    end
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst:AddTag("hat")
    
    anim:SetBank("flowerhat")
    anim:SetBuild("thorn_crown")
    anim:PlayAnimation("anim")    
        
    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/thorn_crown.xml"
   
	inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "USAGE"
    inst.components.fueled:InitializeFuelLevel(TUNING.MOLEHAT_PERISHTIME * usemultiplier)
    inst.components.fueled:SetDepletedFn(onperish)
		
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable.dapperness = TUNING.DAPPERNESS_TINY	
    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

    

    return inst
end

return Prefab( "common/inventory/thorn_crown", fn, assets)